package groowt.view.component.web.lib

import groowt.view.component.web.WebViewComponentContext
import groowt.view.component.web.WebViewComponentScope
import org.junit.jupiter.api.Test

class OutletTests extends AbstractWebViewComponentTests {

    static final class DummyOutletContainer extends Echo implements OutletContainer {

        DummyOutletContainer() {
            super([:])
        }

    }

    @Override
    void configureContext(WebViewComponentContext context) {
        context.configureRootScope(WebViewComponentScope) {
            addWithNoArgConstructor(DummyOutletContainer)
        }
    }

    @Test
    void smokeScreen() {
        doTest('<OutletTests.DummyOutletContainer><Outlet /></OutletTests.DummyOutletContainer>', '')
    }

    @Test
    void withChildren() {
        doTest('<OutletTests.DummyOutletContainer><Echo items={[0, 1, 2]}><Outlet children={items} /></Echo></OutletTests.DummyOutletContainer>', '012')
    }

}
